//+------------------------------------------------------------------+
//|                                            HeikenAshiCount.mq4   |
//|-------------------------------------------------------------------
#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com" 

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Green
#property indicator_color2     Red
#property indicator_width1     4
#property indicator_width2     4
#property indicator_levelcolor White

//
//
//
//
//

extern double levelOb         = 9.0;
extern double levelOs         = -9.0;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double haUp[];
double haDn[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[]; 
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//               

int init()
{
    
    IndicatorBuffers(7);
    SetIndexBuffer(0,haUp); SetIndexStyle(0, DRAW_HISTOGRAM);
    SetIndexBuffer(1,haDn); SetIndexStyle(1, DRAW_HISTOGRAM); 
    SetIndexBuffer(2,Buffer1); 
    SetIndexBuffer(3,Buffer2); 
    SetIndexBuffer(4,Buffer3);
    SetIndexBuffer(5,Buffer4); 
    SetIndexBuffer(6,trend);
    
    SetLevelValue(0,levelOb);
    SetLevelValue(1,0);
    SetLevelValue(2,levelOs);
      
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);   
          
   //
   //
   //
   //
   //
   
   for (pos=limit; pos >= 0; pos--)
   {                    
         
       double haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
       double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
       double haHigh  = MathMax(High[pos],MathMax(haOpen,haClose));
       double haLow   = MathMin(Low[pos], MathMin(haOpen,haClose));
          
       if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
       else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                             Buffer3[pos]=haOpen;
                             Buffer4[pos]=haClose; 
                             
       haUp[pos]  = EMPTY_VALUE;
       haDn[pos]  = EMPTY_VALUE;                      
       trend[pos] = trend[pos+1];
           if (Buffer3[pos] < Buffer4[pos]) trend[pos] =  1;
           if (Buffer3[pos] > Buffer4[pos]) trend[pos] = -1; 
           if (trend[pos] == 1) { haUp[pos] = haUp[pos+1]+1; haDn[pos]=0; }
           if (trend[pos] ==-1) { haDn[pos] = haDn[pos+1]-1; haUp[pos]=0; }  
      } 
      
      //
      //
      //
      //
      //
          
      if (alertsOn)
      {
          if (alertsOnCurrent)
               int whichBar = 0;
          else     whichBar = 1;

          //
          //
          //
          //
          //
         
          if (trend[whichBar] != trend[whichBar+1])
          if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Heiken Ashi Real ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi Real "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}